#!/bin/perl
# This perl script lowercases all filenames in a directory tree(s).
# Usage: perl downcasetree.pl [file/dirname(s)]
#        If no file/dirname is given, the current directory is
#        presumed to be the target.

sub dirlist
{
    local($dir) = @_;
    local($file);
    local($new_file);
    local(@files) = `ls -1 $dir`;

    # Remove newline at end of each file name;
    grep(chop, @files);

    # Loop through all files in directory
    foreach $file (@files)
    {
	# If this file is itself a directory, handle all within it
	if (-d "$dir/$file")
	{
	    dirlist("$dir/$file");
	}

	# If the name has any capital letters in it, rename it
	if ($file =~ /[A-Z]/)
	{
	    $new_file = $file;
	    $new_file =~ tr/A-Z/a-z/;
	    rename("$dir/$file", "$dir/$new_file") ||
		die "Could not rename $dir/$file to $dir/$new_file: $!\n";
	    print "$dir/$file -> $dir/$new_file\n";
	}
    }
}

if (@ARGV == 0)
{
    dirlist('.');
}
else
{ 
    while ($toplevel_file = shift(@ARGV))
    {
	if (-d $toplevel_file)
	{
	    # Process a whole directory
	    dirlist($toplevel_file);
	}
	else
	{
	    # Process one file (tbc: this should be a subroutine; same code is above)
	    $new_file = $toplevel_file;
	    $new_file =~ tr/A-Z/a-z/;
	    (rename("$toplevel_file", "foo.tmp") &&
		rename("foo.tmp", "$new_file")) ||
		die "Could not rename $toplevel_file to $new_file: $!\n";
	    print "$toplevel_file -> $new_file\n";
	}
    }
}
